//index.js
//获取应用实例
const app = getApp()
var util = require('../../utils/util.js')

Page({
  data: {
    //userInfo: {},//微信用户信息
    directionData: ['up', 'right', 'down', 'left'],//E的方向
    lastX: 0,//最后一次滑动横坐标
    lastY: 0,//最后一次滑动横纵标
    eRow: 11,//测视行数
    eValue: '5.0',//当前视力值
    direction: '',//E的方向
    size: '',//E的大小
    countDownStatus: true,//是否显示倒计时蒙层
    //notice: [],//测视提示信息
    rightScore: 0,//正确次数
    errorScore: 0,//错误次数
    totalScore: 0,//总次数
    rowError: 0,//是否已经错过一行
    rowRight: 0, //是否已经对过一行
    leftEye: '',//左眼视力
    rightEye: '',//右眼视力
    testNumber: 1,//左或右眼测试
    time: 3,//倒计时
    distance: '60CM',//测视距离
    ruler: ['4.8','4.9','5.0','5.1','5.2'],//测视标尺
    //successImg: '../../public/img/success.png',
    //errorImg: '../../public/img/error.png',
    smallEyeData: {},//指数视力行数值
    bigEyeData: {},//小数实力行数值
    e60SizeData: {},//60CME字大小数值
    e30SizeData: {},//30CME字大小数值
    rowNumberData: {},//每行E字个数
    rulerType: 'bigEyeData',//行数坐标数组
    //beforeEyeData: {},//当前测视之前行数值
    //afterEyeData: {}//当前测视之后行数值
  },
  onLoad: function () {
    var that = this
    var eRow = that.data.eRow //接口获取E行数
    var eDirection = ''
    var directionData = that.data.directionData;
    var smallEyeData = util.getSmallEyeData()
    var bigEyeData = util.getBigEyeData()
    var e60SizeData = util.getE60SizeData()
    var e30SizeData = util.getE30SizeData()
    var eSizeData
    var rowNumberData = util.getRowNumberData()
    var results = wx.getStorageSync('results')
    //获取当前使用测视距离
    if(this.data.distance == "60CM"){
      eSizeData = e60SizeData
    }else{
      eSizeData = e30SizeData
    }
    var size = eSizeData[eRow]
    var n = Math.floor(Math.random() * directionData.length + 1) - 1
    eDirection = directionData[n];//随机取一个方向
    that.setData({
      smallEyeData: smallEyeData,
      bigEyeData: bigEyeData,
      eSizeData: eSizeData,
      e60SizeData: e60SizeData,
      e30SizeData: e30SizeData,
      rowNumberData: rowNumberData,
      size: size,//初始化E值大小
      direction: eDirection,//初始化E值方向
      eRow: eRow,
    })
    //如果有历史测视记录
    if (results[0]) {
      eRow = results[0].eRow
      size = eSizeData[eRow]
      that.getRuler(results[0].eRow)
      that.setData({
        eRow: eRow,
        size: size
      })
    }
    that.timeInterval()//倒计时
    var text = '左眼测视开始,请遮住您的左眼' 
    that.playVoice(text) //语音播报
  },
  //获取用户选择方向并提交给结果校验函数
  choseDirection: function(event){
    var choseDirection = event.target.dataset.choiceDirection;
    this.checkTesting(choseDirection)
  },
  //滑动手势检查
  handletouchend: function (event) {
    //console.log(event.changedTouches[0])
    let currentX = event.changedTouches[0].pageX
    let currentY = event.changedTouches[0].pageY
    let tx = currentX - this.data.lastX
    let ty = currentY - this.data.lastY
    //let text = ""
    var choseDirection
    //左右方向滑动
    if (Math.abs(tx) > Math.abs(ty)) {
      if (tx < 0)
        //text = "向左滑动"
        choseDirection = this.data.directionData[3]
      else if (tx > 0)
        //text = "向右滑动"
        choseDirection = this.data.directionData[1]
    }
    //上下方向滑动
    else {
      if (ty < 0)
        //text = "向上滑动"
        choseDirection = this.data.directionData[0]
      else if (ty > 0)
        //text = "向下滑动"
        choseDirection = this.data.directionData[2]
    }
    //将当前坐标进行保存以进行下一次计算
    this.data.lastX = currentX
    this.data.lastY = currentY
    /*this.setData({
      text: text,
    });*/
    this.checkTesting(choseDirection)
  },
  //滑动开始处理
  handletouchtart: function (event) {
    //console.log(event.touches[0])
    this.data.lastX = event.touches[0].pageX
    this.data.lastY = event.touches[0].pageY
  },
  handletap: function (event) {
    //console.log(event)
  },

  //显示视力结果 left:左眼视力、rightEye:右眼视力、time:测视结束时间、eRow:测视结束行数
  showResult: function (leftEye, rightEye, time, eRow) {

    wx.navigateTo({
      url: '../result/result?leftEye=' + leftEye + '&rightEye=' + rightEye + '&time=' + time + '&eRow=' + eRow
    })
  },
  //倒计时
  timeInterval: function () {
    wx.setNavigationBarTitle({
      title: '准备测视'
    });
    var that = this;
    var title;
    if (that.data.testNumber == 1){
      title = "当前测视【左眼】";
    }else{
      title = "当前测视【右眼】";
    }
    var timer = setInterval(function () {
      // 判断是否小于0
      var nowTime = that.data.time;
      if (nowTime > 0) {
        that.setData({
          time: nowTime - 1
        });
        return;
      }else{
          clearInterval(timer);
          that.setData({
            time: 3,
            countDownStatus:'none'
          });
          //设置小程序标题
          wx.setNavigationBarTitle({
            title: title
          });
      }
      clearInterval(timer);
    }, 1000);
  },
  //校验本次测试结果
  checkTesting:function (choiceDirection) {
    //console.log(event.target.dataset)
    //var noticeImg = []//提示图标
    var eRow = this.data.eRow//e所在行数
    var rightNumber//正确数量
    var errorNumber//错误数量
    var totalNumber//测视总数量
    var testNumber = this.data.testNumber//当前测试类型
    var leftEye//左眼视力
    var rightEye//右眼视力
    var eDirection//E方向
    var oldRow//原来e所在行数
    var rowError = this.data.rowError//是否已经下降过测视行数
    var rowRight = this.data.rowRight//是否已经升过测视行数
    var that = this
    //noticeImg = this.data.notice
    if (choiceDirection == this.data.direction) {//测视正确
      //noticeImg = noticeImg.concat([this.data.successImg])
      rightNumber = this.data.rightScore + 1
      errorNumber = this.data.errorScore
      totalNumber = this.data.totalScore + 1
    } else {
      //noticeImg = noticeImg.concat([this.data.errorImg])
      errorNumber = this.data.errorScore + 1
      rightNumber = this.data.rightScore
      totalNumber = this.data.totalScore + 1
    }
    //判断用户选择方向是否正确
    //4.0还错，直接4.0
    if (errorNumber == 1 && eRow == 1) {
      eRow = 1
      errorNumber = 0
      rightNumber = 0
      totalNumber = 0
      rowError = 1
      that.getRuler(eRow)
      if (rowRight == 1) {
        this.setEyeSight(testNumber, 1)
        return
      }
    //4.7以下不能错1个
    } else if (errorNumber >= 1 && eRow <= 8) {
      eRow = eRow - 1
      errorNumber = 0
      rightNumber = 0
      totalNumber = 0
      rowError = 1
      that.getRuler(eRow)
      if(rowRight == 1){
        this.setEyeSight(testNumber,1)
        return 
      }
    //4.8-5.0不能错2个
    } else if (errorNumber >= 2 && eRow > 8 && eRow <= 11) {
      eRow = eRow - 1
      errorNumber = 0
      rightNumber = 0
      totalNumber = 0
      rowError = 1
      that.getRuler(eRow)
      if (rowRight == 1) {
        this.setEyeSight(testNumber,1)
        return
      }
    //5.0以上不能错3个
    } else if (errorNumber >= 3 && eRow > 11) {
      eRow = eRow - 1
      errorNumber = 0
      rightNumber = 0
      totalNumber = 0
      rowError = 1
      that.getRuler(eRow)
      if (rowRight == 1) {
        this.setEyeSight(testNumber,1)
        return
      }
    //本次用户选择方向正确
    } else {
      if(totalNumber >= this.data.rowNumberData[eRow]) {
        rowRight = 1
        if (rowError == 1) {
          //显示测视结果
          eRow = eRow
          errorNumber = 0
          rightNumber = 0
          totalNumber = 0
          rowError = 0
          rowRight = 0
          this.setEyeSight(testNumber,0)
          return
        } else {
          eRow = eRow + 1
          errorNumber = 0
          rightNumber = 0
          totalNumber = 0
          rowRight = 1
          that.getRuler(eRow)
        }
      }
    }
    var Arr = this.data.directionData;
    var n = Math.floor(Math.random() * Arr.length + 1) - 1;
    eDirection = Arr[n];
    this.setData({
      direction: eDirection,
      //notice: noticeImg,
      size: this.data.eSizeData[eRow],
      eRow: eRow,
      rightScore: rightNumber,
      errorScore: errorNumber,
      totalScore: totalNumber,
      rowError: rowError,
      rowRight: rowRight
    })
    //event.target.dataset.direction
  },
  //保存本次测视值 testNumber:左/右眼测视，1：左眼、2：右眼；error:是否有错一行，1：错一行，0：没错过
  setEyeSight: function(testNumber,error){
    var leftEye
    var rightEye
    var eRow = this.data.eRow
    if (testNumber == 1) {
      leftEye = this.getEValue(error);//左眼视力
      testNumber = 2
      this.setData({
        testNumber: testNumber,
        leftEye: leftEye,
        countDownStatus: 'true',
        rowError: 0,
        rowRight: 0,
        rightScore: 0,
        errorScore: 0,
        totalScore: 0
      })
      this.timeInterval()
      var text = '右眼测视开始,请遮住您的右眼'
      this.playVoice(text)
    } else {
      rightEye = this.getEValue(error);//右眼视力
      testNumber = 1
      this.setData({
        testNumber: testNumber,
        rightEye: rightEye,
        rowError: 0,
        rowRight: 0,
        rightScore: 0,
        errorScore: 0,
        totalScore: 0
      })
      //todo 上传训练结果
      var text = '测视结束'
      this.playVoice(text)
      this.uploadVision()
      var time = util.formatTime(new Date()); 
      this.showResult(this.data.leftEye, rightEye, time, eRow)
    }
  },
  //获取视力行数值 error:是否错过一行
  getEValue: function (error) {
    var eyeSight
    var eRow = this.data.eRow
    if (error == 1 && this.data.rowRight == 1) {
      eRow = eRow + 0 - 1
    }
    //console.log(eRow)
    if(this.data.rulerType == "smallEyeData"){
      eyeSight = this.data.smallEyeData[eRow]
    }else{
      eyeSight = this.data.bigEyeData[eRow]
    }
    return eyeSight  
  },
  //修改测视距离
  editDistance: function(){
    var tap
    var that = this
    wx.showActionSheet({
      itemList: ['30CM', '60CM'],
      success: function (res) {
        //console.log(res)
        tap = res.tapIndex
        that.setDistance(tap);
      }
    })
  },
  //修改测视标尺
  editRuler: function () {
    var tap
    var that = this
    wx.showActionSheet({
      itemList: ['小数记录', '5分记录'],
      success: function (res) {
        tap = res.tapIndex
        that.setRuler(tap);
      }
    })
  },
  //设置最新标尺数组
  setRuler: function (event) {
    var rulerType
    var ruler
    var that = this
    var eRow = this.data.eRow
    if (event == 0) {
      rulerType = "smallEyeData"
    } else {
      rulerType = "bigEyeData"
    }
    this.setData({
      rulerType: rulerType
    })
    ruler = that.getRuler(eRow)
  },
  //获取最新视力标尺数组
  getRuler: function(eRow){
    var ruler = []
    var eValue
    //var eRow = this.data.eRow
    var eyeData
    var eRow = parseInt(eRow)
    if (this.data.rulerType == "smallEyeData") {
      eValue = this.data.smallEyeData[eRow]
      eyeData = this.data.smallEyeData
    } else {
      eValue = this.data.bigEyeData[eRow]
      eyeData = this.data.bigEyeData
    }
    for (var i = 0; i < 5; i++) {
      var oldERow = eRow
      if(i == 0){
        oldERow = eRow - 2
        if(oldERow < 0){
          ruler[i] = 0
        }else{
          ruler[i] = eyeData[oldERow]
        }
      }else if(i == 1){
        oldERow = eRow - 1
        if (oldERow < 0) {
          ruler[i] = 0
        } else {
          ruler[i] = eyeData[oldERow]
        }
      } else if (i == 2) {
        ruler[i] = eValue
      } else if (i == 3) {
        oldERow = eRow + 1
        if (oldERow > 14) {
          ruler[i] = 0
        } else {
          ruler[i] = eyeData[oldERow]
        }
      } else{
        oldERow = eRow + 2
        if (oldERow > 14) {
          ruler[i] = 0
        } else {
          ruler[i] = eyeData[oldERow]
        }
      }    
    }
    this.setData({
      eValue: eValue,
      ruler: ruler
    })
  },
  //设置最新距离数组
  setDistance: function (event) {
    //重新获取distance,设置E字大小
    var distance
    var size
    var eSizeData
    if(event == 0){
      distance = '30CM'
      eSizeData = this.data.e30SizeData
    }else{
      distance = '60CM'
      eSizeData = this.data.e60SizeData
    }
    size = eSizeData[this.data.eRow]
    this.setData({
      distance: distance,
      size: size,
      eSizeData: eSizeData
    })
  },
  //播放语音信息
  playVoice: function(event){
    var baidu_token = wx.getStorageSync('baidu_token');
    var text = event
    //播放声音
    const backgroundAudioManager = wx.getBackgroundAudioManager()
    backgroundAudioManager.src = 'http://tsn.baidu.com/text2audio?tex=' + text + '&lan=zh&cuid=ootesting&ctp=1&tok=' + baidu_token.access_token // 设置了 src 之后会自动播放
    //结束播放声音
  },
  //上传视力结果数据
  uploadVision: function (event) {
    var userId = wx.getStorageSync('userId');
    var text = event
    var that = this
    var timestamp = Date.parse(new Date()) / 1000;
    wx.request({
      url: app.server + 'SmallProgram/WechatSight/addUserVision',
      data: {
        userId: userId,
        leftEye: this.data.leftEye,
        rightEye: this.data.rightEye,
        testDate: timestamp
      },
      success: function (event) {
        console.log(event)
      }
    })
  }

})
